Codeforces Round #280 (Div. 2) A B C 暴力 水 贪心

A. Vanya and Cubes
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Vanya got n cubes. He decided to build a pyramid from them. Vanya wants to build the pyramid as follows: the top level of the pyramid must consist of 1 cube, the second level must consist of 1 + 2 = 3 cubes, the third level must have 1 + 2 + 3 = 6 cubes, and so on. Thus, the i-th level of the pyramid must have 1 + 2 + ... + (i - 1) + i cubes.

Vanya wants to know what is the maximum height of the pyramid that he can make using the given cubes.

Input

The first line contains integer n (1 ≤ n ≤ 104) — the number of cubes given to Vanya.

Output

Print the maximum possible height of the pyramid in the single line.

Examples
input
1
output
1
input
25
output
4
Note

Illustration to the second sample:

Codeforces Round #280 (Div. 2) A B C 暴力 水 贪心

题意:给你n个方块 按照如图的方式摆放 问最多能摆放多少层?

题解:暴力层数 判断需要多少方块

 /******************************
code by drizzle
blog: www.cnblogs.com/hsd-/
^ ^ ^ ^
O O
******************************/
#include<bits/stdc++.h>
#include<iostream>
#include<cstring>
#include<cstdio>
#include<map>
#include<algorithm>
#include<queue>
#define ll __int64
using namespace std;
int n;
int a[];
int main()
{
scanf("%d",&n);
int sum=;
for(int i=;i<=;i++)
{
sum=sum+i*(i+)/;
if(sum==n)
{
cout<<i<<endl;
return ;
}
if(sum>n)
{
cout<<i-<<endl;
return ;
}
}
return ;
}
B. Vanya and *s
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Vanya walks late at night along a straight street of length l, lit by n *s. Consider the coordinate system with the beginning of the street corresponding to the point 0, and its end corresponding to the point l. Then the i-th * is at the point ai. The * lights all points of the street that are at the distance of at most d from it, where d is some positive number, common for all *s.

Vanya wonders: what is the minimum light radius d should the *s have to light the whole street?

Input

The first line contains two integers nl (1 ≤ n ≤ 1000, 1 ≤ l ≤ 109) — the number of *s and the length of the street respectively.

The next line contains n integers ai (0 ≤ ai ≤ l). Multiple *s can be located at the same point. The *s may be located at the ends of the street.

Output

Print the minimum light radius d, needed to light the whole street. The answer will be considered correct if its absolute or relative error doesn't exceed 10 - 9.

Examples
input
7 15
15 5 3 7 9 14 0
output
2.5000000000
input
2 5
2 5
output
2.0000000000
Note

Consider the second sample. At d = 2 the first * will light the segment [0, 4] of the street, and the second * will light segment[3, 5]. Thus, the whole street will be lit.

题意:l长的路 给你n个路灯的坐标 问你最小的路灯照射半径使得路上都被照亮

题解:寻找最长的路灯间隔/2 并与第一个路灯,最后一个路灯照射的边界比较取最大值输出

 /******************************
code by drizzle
blog: www.cnblogs.com/hsd-/
^ ^ ^ ^
O O
******************************/
#include<bits/stdc++.h>
#include<iostream>
#include<cstring>
#include<cstdio>
#include<map>
#include<algorithm>
#include<queue>
#define ll __int64
using namespace std;
int n,l;
double a[];
int main()
{
scanf("%d %d",&n,&l);
for(int i=;i<n;i++)
scanf("%lf",&a[i]);
sort(a,a+n);
double minx=;
for(int i=;i<n;i++)
{
if(a[i-]==a[i])
continue;
minx=max(minx,a[i]-a[i-]);
}
minx=max(minx/2.0,max(a[],l-a[n-]));
printf("%f\n",minx);
return ;
}
C. Vanya and Exams
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Vanya wants to pass n exams and get the academic scholarship. He will get the scholarship if the average grade mark for all the exams is at least avg. The exam grade cannot exceed r. Vanya has passed the exams and got grade ai for the i-th exam. To increase the grade for the i-th exam by 1 point, Vanya must write bi essays. He can raise the exam grade multiple times.

What is the minimum number of essays that Vanya needs to write to get scholarship?

Input

The first line contains three integers nravg (1 ≤ n ≤ 105, 1 ≤ r ≤ 109, 1 ≤ avg ≤ min(r, 106)) — the number of exams, the maximum grade and the required grade point average, respectively.

Each of the following n lines contains space-separated integers ai and bi (1 ≤ ai ≤ r, 1 ≤ bi ≤ 106).

Output

In the first line print the minimum number of essays.

Examples
input
5 5 4
5 2
4 7
3 1
3 2
2 5
output
4
input
2 5 4
5 2
5 2
output
0
Note

In the first sample Vanya can write 2 essays for the 3rd exam to raise his grade by 2 points and 2 essays for the 4th exam to raise his grade by 1 point.

In the second sample, Vanya doesn't need to write any essays as his general point average already is above average.

题意:n门科目 每门满分r 要求所有科目的均分大于等于avg才能获得奖学金

对于每门科目都有两个值 a为得分 b为每增加一分需要看的文章的数量 输出想要获得奖学金 需要看的文章的数量的最小值

题解:贪心策略 对于每门科目按照b升序排

 /******************************
code by drizzle
blog: www.cnblogs.com/hsd-/
^ ^ ^ ^
O O
******************************/
#include<bits/stdc++.h>
#include<iostream>
#include<cstring>
#include<cstdio>
#include<map>
#include<algorithm>
#include<queue>
#define ll __int64
using namespace std;
ll n,r,avg;
struct node
{
ll a,b;
}N[];
bool cmp(struct node aa,struct node bb)
{
return aa.b<bb.b;
}
int main()
{
scanf("%I64d %I64d %I64d",&n,&r,&avg);
ll sum=;
for(int i=;i<n;i++)
{
scanf("%I64d %I64d",&N[i].a,&N[i].b);
sum+=N[i].a;
}
if(avg*n<=sum)
{
printf("0\n");
return ;
}
sum=avg*n-sum;
sort(N,N+n,cmp);
ll ans=;
for(int i=;i<n;i++)
{
ll exm=N[i].a;
if(exm==r)
continue;
if(sum>=(r-exm))
{
ans=ans+(r-exm)*N[i].b;
sum=sum-(r-exm);
}
else
{
ans=ans+sum*N[i].b;
sum=;
}
if(sum==)
break;
}
printf("%I64d\n",ans);
return ;
}
上一篇:apache服务器启动时提示httpd: apr_sockaddr_info_get() failed for


下一篇:VMware ESXi 启动时提示引导错误:不是VMware引导槽。找不到管理程序(bank6 not a vmware boot bank no hypervisor found)